c       SUBROUTINE JMAT(X,Y,Z,DNDXI,DNDETA,DNDZETA,DXIF,DETIF,DZEIF,
c     +                 JM,JINV,DETJ,NN,NMTE,NKIND)
      SUBROUTINE JMAT
      use fem_arrays
      implicit integer (i-n)
      implicit double precision (a-h,o-z)
c------------------------------------------------
C CALCULATE J-MAT (FOR 3-DIMENSION)
C
      DO 5 II = 1,IDIM
       DO 6 JJ = 1,IDIM
         JM(II,JJ)=0.0
   6  CONTINUE
   5  CONTINUE
C
       NKK = NKINF(IE)
       NIE = NMTE(IE)
       IF (NKK.EQ.1) THEN
       DO 15 I=1,NIE
       NNIE = NN(I,IE)
       JM(1,1)=JM(1,1)+DXIF(I)  *COORD(1,NNIE)
       JM(2,1)=JM(2,1)+DETIF(I) *COORD(1,NNIE)
       JM(3,1)=JM(3,1)+DZEIF(I) *COORD(1,NNIE)
       JM(1,2)=JM(1,2)+DXIF(I)  *COORD(2,NNIE)
       JM(2,2)=JM(2,2)+DETIF(I) *COORD(2,NNIE)
       JM(3,2)=JM(3,2)+DZEIF(I) *COORD(2,NNIE)
       JM(1,3)=JM(1,3)+DXIF(I)  *COORD(3,NNIE)
       JM(2,3)=JM(2,3)+DETIF(I) *COORD(3,NNIE)
       JM(3,3)=JM(3,3)+DZEIF(I) *COORD(3,NNIE)
c
 15   CONTINUE
c
C MAKE J-INVERSE
c
        DETJ=JM(1,1)*(JM(2,2)*JM(3,3)-JM(3,2)*JM(2,3))
     &      +JM(1,2)*(JM(3,1)*JM(2,3)-JM(2,1)*JM(3,3))
     &      +JM(1,3)*(JM(2,1)*JM(3,2)-JM(3,1)*JM(2,2))
c
        DETJI=1.0/DETJ
        JINV(1,1)= (JM(2,2)*JM(3,3)-JM(3,2)*JM(2,3))*DETJI
        JINV(2,2)= (JM(1,1)*JM(3,3)-JM(1,3)*JM(3,1))*DETJI
        JINV(3,3)= (JM(1,1)*JM(2,2)-JM(1,2)*JM(2,1))*DETJI
C
        JINV(2,1)= (JM(3,1)*JM(2,3)-JM(2,1)*JM(3,3))*DETJI 
        JINV(1,2)= (JM(1,3)*JM(3,2)-JM(1,2)*JM(3,3))*DETJI
C
        JINV(3,1)= (JM(2,1)*JM(3,2)-JM(3,1)*JM(2,2))*DETJI 
        JINV(1,3)= (JM(1,2)*JM(2,3)-JM(1,3)*JM(2,2))*DETJI
C
        JINV(3,2)= (JM(1,2)*JM(3,1)-JM(3,2)*JM(1,1))*DETJI 
        JINV(2,3)= (JM(2,1)*JM(1,3)-JM(2,3)*JM(1,1))*DETJI
c------------------------------------------------
c
        ELSE
       DO 10 I=1,NIE
       NNIE = NN(I,IE)
       JM(1,1)=JM(1,1)+DNDXI(I)  *COORD(1,NNIE)
       JM(2,1)=JM(2,1)+DNDETA(I) *COORD(1,NNIE)
       JM(3,1)=JM(3,1)+DNDZETA(I)*COORD(1,NNIE)
       JM(1,2)=JM(1,2)+DNDXI(I)  *COORD(2,NNIE)
       JM(2,2)=JM(2,2)+DNDETA(I) *COORD(2,NNIE)
       JM(3,2)=JM(3,2)+DNDZETA(I)*COORD(2,NNIE)
       JM(1,3)=JM(1,3)+DNDXI(I)  *COORD(3,NNIE)
       JM(2,3)=JM(2,3)+DNDETA(I) *COORD(3,NNIE)
       JM(3,3)=JM(3,3)+DNDZETA(I)*COORD(3,NNIE)
c
 10    CONTINUE
c
ccccc check jacobian
cc       write(98,111)jm(1,1),jm(1,2),jm(1,3)
cc       write(98,111)jm(2,1),jm(2,2),jm(2,3)
cc       write(98,111)jm(3,1),jm(3,2),jm(3,3)
cc 111   format(3e15.7)
c
C MAKE J-INVERSE
c
        DETJ=JM(1,1)*(JM(2,2)*JM(3,3)-JM(3,2)*JM(2,3))
     &      +JM(1,2)*(JM(3,1)*JM(2,3)-JM(2,1)*JM(3,3))
     &      +JM(1,3)*(JM(2,1)*JM(3,2)-JM(3,1)*JM(2,2))
        DETJI=1.0/DETJ
        JINV(1,1)= (JM(2,2)*JM(3,3)-JM(3,2)*JM(2,3))*DETJI
        JINV(2,2)= (JM(1,1)*JM(3,3)-JM(1,3)*JM(3,1))*DETJI
        JINV(3,3)= (JM(1,1)*JM(2,2)-JM(1,2)*JM(2,1))*DETJI
C
        JINV(2,1)= (JM(3,1)*JM(2,3)-JM(2,1)*JM(3,3))*DETJI 
        JINV(1,2)= (JM(1,3)*JM(3,2)-JM(1,2)*JM(3,3))*DETJI
C
        JINV(3,1)= (JM(2,1)*JM(3,2)-JM(3,1)*JM(2,2))*DETJI 
        JINV(1,3)= (JM(1,2)*JM(2,3)-JM(1,3)*JM(2,2))*DETJI
C
        JINV(3,2)= (JM(1,2)*JM(3,1)-JM(3,2)*JM(1,1))*DETJI 
        JINV(2,3)= (JM(2,1)*JM(1,3)-JM(2,3)*JM(1,1))*DETJI
c------------------------------------------------
        ENDIF
       RETURN
       END
